function result=deltabeta3(mpdates,betaT,lambda,year,month,day,TimeV);
%Constructs a series of delta_betas at the monthly frequency
%This is a simplified version of deltabeta.m

shockV_avg  =[];   shockV_final=[]; betabeforeV_avg=[]; betaafterV_avg=[];
for ty=year(1):year(end);   
    for tm=1:12;  
     [i_shock]=find( mpdates(:,3)==ty &  mpdates(:,2)==tm ); 
     
     if isempty(i_shock)==1; 
         shockV_avg  =[shockV_avg;   ty,tm, ty+(tm-1)/12,zeros(1,size(betaT,2)-4)]; 
         shockV_final=[shockV_final; ty,tm, ty+(tm-1)/12,zeros(1,size(betaT,2)-4)];
         betabeforeV_avg =[betabeforeV_avg;  ty,tm, ty+(tm-1)/12,zeros(1,size(betaT,2)-4)];
         betaafterV_avg  =[betaafterV_avg;   ty,tm, ty+(tm-1)/12,zeros(1,size(betaT,2)-4)];
     else;
         shockV_ii_avg=[]; betabeforeV_ii_avg =[]; betaafterV_ii_avg  =[];
         for ii=i_shock'; 
         [i_beta]=find( betaT(:,1)==mpdates(ii,3) &  betaT(:,2)==mpdates(ii,2) &  betaT(:,3)==mpdates(ii,1) );
         weight=(31-mpdates(ii,1)-1)/31;
         shockV_ii_avg   =[shockV_ii_avg; betaT(i_beta,[1,2]), ty+(tm-1)/12, (betaT(i_beta+1,4:end-1)-betaT(i_beta-1,4:end-1))*weight];
         shockV_ii_final =               [betaT(i_beta,[1,2]), ty+(tm-1)/12, (betaT(i_beta+1,4:end-1)-betaT(i_beta-1,4:end-1))*weight]; 
         betabeforeV_ii_avg =[betabeforeV_ii_avg;  ty,tm, ty+(tm-1)/12,betaT(i_beta-1,4:end-1)];
         betaafterV_ii_avg  =[betaafterV_ii_avg;   ty,tm, ty+(tm-1)/12,betaT(i_beta+1,4:end-1)];
         end;
     shockV_avg=[shockV_avg; mean(shockV_ii_avg,1)];
     shockV_final=[shockV_final; shockV_ii_final];
     betabeforeV_avg=[betabeforeV_avg; mean(betabeforeV_ii_avg,1)];
     betaafterV_avg =[betaafterV_avg;  mean(betaafterV_ii_avg,1)];
     end;
     
    end;
end; 
result.shock=shockV_avg;
result.betabeforeV = betabeforeV_avg;
result.betaafterV  = betaafterV_avg;    
