%The data come from the Stata file from Ramey's webpage, appropriately
%modified, in the file varspfORIGINAL.m  

fn=figure;
H=[1;2;3;4];
shock911=[0.000414094;	0.021279931;	0.044437096;	0.040297154]; shock911time=2001.5;
shockcarterreaganbuidup=[0.02782605;	0.026818598;	0.035302233;	0.049055107]; shockcarterreaganbuiduptime=[1980];
shockcarterreaganbuidup=smoothTall(shockcarterreaganbuidup,2);
shock911=smoothTall(shock911,2);
plot(H,shock911,'c','LineWidth',3); hold on; plot(H,shockcarterreaganbuidup,'-.m','LineWidth',3)
legend('9/11 Shock','Carter-Reagan Buildup Shock','Location','Best'); 
xlabel('Forecast Horizon');
title('SPF-based Fiscal Policy Shock')
set(gca,'FontSize',12)
saveas(fn,'fiscalshock', 'epsc')

%Matrix A's structure:
%h=1 SPFforecasted SPFactual
%h=2 SPFforecasted SPFactual
%h=3 SPFforecasted SPFactual
%h=4 SPFforecasted SPFactual

eventcarterreaganbuidup=[0.001177986, 0.029004036; 0.007785162, 0.03460376; -0.003663127, 0.031639107; 0.002489254, 0.051544361];
event911=[0.006278032, 0.009048245; 0.006599998, 0.022935336; 0.004509657, 0.040385034; 0.004024275, 0.041163616];

fn=figure; 
subplot(2,1,1); plot(H,smoothTall(eventcarterreaganbuidup(:,1),2),'--m','LineWidth',3); 
hold on; plot(H,smoothTall(eventcarterreaganbuidup(:,2),2),'--*m','LineWidth',3,'MarkerSize',10); hold off; 
legend('Forecasted','Actual','Location','Best'); 
xlabel('Forecast Horizon'); 
title('Carter-Reagan Buildup (1980Q1)')
set(gca,'FontSize',12)

subplot(2,1,2); plot(H,smoothTall(event911(:,1),2),'-c','LineWidth',3); 
hold on; plot(H,smoothTall(event911(:,2),2),'-*c','LineWidth',3,'MarkerSize',10);  
hold off;
legend('Forecasted','Actual','Location','Best'); 
xlabel('Forecast Horizon'); 
title('9/11 (2001Q3)')
set(gca,'FontSize',12)
saveas(fn,'episode911', 'epsc')
