load taxsim.txt;
x = [1000:1000:600000];
tax2011 = taxsim(1:600,7);
tax2012 = taxsim(601:1200,7);
tax2016 = taxsim(1201:1800,7);
tax2017 = taxsim(1801:2400,7);

fn=figure; plot(x,tax2011,'m-'); hold on;
plot(x,tax2012,'m--*'); hold off;
title('2012 Tax Relief and Job Creation Act');
xlabel('Wage Income'); ylabel('Marginal Tax Rate');
legend('2011','2012','Location','Best'); 
set(gca,'FontSize',12); saveas(fn,'taxschedule2012', 'epsc')

fn=figure; plot(x,tax2012-tax2011,'m--','LineWidth',3);
xlabel('Wage Income'); title('2012 Tax Relief and Job Creation Act');
ylabel('Marginal Tax Rate Change')
saveas(gcf,'taxchange2012','epsc');
set(gca,'FontSize',12); saveas(fn,'shock2012', 'epsc')


fn=figure; plot(x,tax2016,'c-'); hold on;
plot(x,tax2017,'c-*');
title('2017 Tax Cuts and Jobs Act');
xlabel('Wage Income'); ylabel('Marginal Tax Rate');
legend('2016','2017','Location','Best');
set(gca,'FontSize',12); saveas(fn,'taxschedule2017', 'epsc')

fn=figure; plot(x,tax2017-tax2016,'c--','LineWidth',3);
xlabel('Wage Income'); ylabel('Marginal Tax Rate');
title('2017 Tax Cuts and Jobs Act')
saveas(gcf,'taxchange2017','epsc');
set(gca,'FontSize',12); saveas(fn,'taxshock2012', 'epsc')

