function Zv=fromshockonlytoeverydate(mpdates,Z,year,month,TimeV);
%Constructs a series of instruments for every month from a series that only
%has instruments if different from zero (associates zero to cases where
%there is no shock/instrument)

Zv  =[];    
for ty=year(1):year(end);   
    for tm=1:12;  
     [i_shock]=find( mpdates(:,3)==ty &  mpdates(:,2)==tm ); 
     
     if isempty(i_shock)==1; 
         Zv  =[Zv;   ty,tm, ty+(tm-1)/12,zeros(1,size(Z,2)-3)]; 
     else;
         shockV_ii_avg=[]; 
         for ii=i_shock';  
         [i_beta]=find( Z(:,1)==mpdates(ii,1) &  Z(:,2)==mpdates(ii,2) &  Z(:,3)==mpdates(ii,3) );
        % Z(i_beta,[2,3]),  Z(i_beta,:),
         shockV_ii_avg   =[shockV_ii_avg; ty, tm, ty+(tm-1)/12, Z(i_beta,4:end)];
        % Zv   =[Zv; Z(i_beta,[1,2]), ty+(tm-1)/12, Z(i_beta+1,4:end)];
         end;
     Zv=[Zv; mean(shockV_ii_avg,1)];
     end;
     
    end;
end; 
%result.shock=Zv;

