function main_IRF(betaT,day,month,year,TimeV,mpdates,Y,period,select_beta); 
%select is to select a subset of the betas: for betas use [5,6] to get beta2 and beta3, for yields
%use [4,6,9] -- important, it has to be a row vector
B = 1000;
H = 20;
p=2;
nbeta=size(select_beta,2); 
lambda = 0.0609;
result=deltabeta3(mpdates,betaT,lambda,year,month,day,TimeV);
shock=result.shock;
betabeforeV=result.betabeforeV;
betaafterV =result.betaafterV;    
deltabetaV=[]; irfinfV=[]; irfoutputV=[];

if period=='conven';        shockhere=shock(61:226,select_beta);    Yhere=Y(61:226,:); %61:228
elseif period=='unconv';    shockhere=shock(227:end-6,select_beta); Yhere=Y(227:end,:); 
end;

irf_inf=[]; irf_output=[]; irf_output1=[]; p=2; %p=2 means 1 lag

for h=2:H
    %OLS regressions
    X=[shockhere(p+1:end-h+1,:),Yhere(p+1:end-h+1,1:2),shockhere(p:end-h,:),Yhere(p:end-h,1:2),ones(size(shockhere(h+p:end,:),1),1)];
        IRFinfhere=olsbeta(Yhere(h+p:end,1),X); ehat=olsres(Yhere(h+p:end,1),X);
        irf_inf=[irf_inf; IRFinfhere(1:nbeta)]; 
        qn=2; 
        varbeta_inf = olsvarbetanw(Yhere(h+p:end,1),X,qn);
        
        IRFoutputhere=olsbeta(Yhere(h+p:end,2),X);
        varbeta_output = olsvarbetanw(Yhere(h+p:end,2),X,qn);
        irf_output=[irf_output; IRFoutputhere(1:nbeta)];
                
end; 

%Impose impact=0
irf_inf=[irf_inf(1,:).*0; irf_inf(1:end,:)];
irf_output=[irf_output(1,:).*0; irf_output(1:end,:)]; 
irf_inf=smoothT4(irf_inf); irf_output=smoothT4(irf_output);

for tt=1:size(shock,1)-6
    if sum(abs(shock(tt,4:6)))<eps
        continue
    end
    
    %Frechet derivatives
    irf_inf50    = irf_inf*shock(tt,select_beta)';
    irf_output50 = irf_output*shock(tt,select_beta)';


    %Bands
    ta=1.64; 
    var_frechet_inf       = shock(tt,select_beta)*varbeta_inf(1:nbeta,1:nbeta)*shock(tt,select_beta)'; %IRF_inf1(floor(0.05*B)+1,:);
    irf_inf16    = [0; irf_inf50(2:end,:)-ta*sqrt(var_frechet_inf)];
    irf_inf84    = [0; irf_inf50(2:end,:)+ta*sqrt(var_frechet_inf)];
    var_frechet_output    = shock(tt,select_beta)*varbeta_output(1:nbeta,1:nbeta)*shock(tt,select_beta)'; %IRF_inf1(floor(0.05*B)+1,:);
    irf_output16 = [0; irf_output50(2:end,:)-ta*sqrt(var_frechet_output)];
    irf_output84 = [0; irf_output50(2:end,:)+ta*sqrt(var_frechet_output)];
    
     decomp_inf     = bsxfun(@times,irf_inf,shock(tt,select_beta)); %%max(max(decomp_inf-decomp_inf1)), sdfsdf
     decomp_output  = bsxfun(@times,irf_output,shock(tt,select_beta)); %%%max(max(decomp_output-decomp_output1)), sdfsdf

    fn=figure('visible','off'); 
    subplot(1,2,1); Hv=[0:1:H-1];
    plot(Hv,irf_inf16','--r','LineWidth',2); hold on;
    plot(Hv,irf_inf84','--r','LineWidth',2); 
    Hv2=[Hv,fliplr(Hv)]; inbetween=[irf_inf16',fliplr(irf_inf84')]; fill(Hv2, inbetween,[1 0.6 0.3]);
    plot(Hv,irf_inf50','r','LineWidth',3);      
    hold off;
    ylabel('Percent','FontSize',14); xlabel('Horizon','FontSize',14);
    str1=['title(''Inflation IRF on ',num2str(shock(tt,2)),'/',num2str(shock(tt,1)),''',''FontSize'',14',');'];
    eval(str1);
    subplot(1,2,2); 
      
    if nbeta==2; %when nbeta==2 plot the change in NS
        betabefore=betabeforeV(tt,:); 
        betaafter=betaafterV(tt,:); 
        betadiff=betaafter-betabefore;
        tau=[1:1:120];
        TS_before=betabefore(1,4)+betabefore(1,5)*(1-exp(-lambda*tau))./(lambda*tau)+betabefore(1,6)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
        TS_after=betaafter(1,4)+betaafter(1,5)*(1-exp(-lambda*tau))./(lambda*tau)+betaafter(1,6)*((1-exp(-lambda*tau))./(lambda*tau)-exp(-lambda*tau));
        plot(tau,TS_before,'b','LineWidth',2); hold on; plot(tau,TS_after,'r-*');  
        str2=['title(''',num2str(betabefore(2)),'/',num2str(betabefore(1)),''',''FontSize'',14',');']; 
        eval(str2);
        legend('Yield Curve Before','Yield Curve After','Location','Best'); 
        xlabel('Maturity','FontSize',14); ylabel('Yield (%)','FontSize',14); hold off; 
        if period=='conven'; saveas(fn,strcat('figuresIRFSsmooth/conventional/inflation',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        elseif period=='unconv'; saveas(fn,strcat('figuresIRFSsmooth/unconventional/inflation',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        end; 
        deltabetaV=[deltabetaV; betabefore(2), betabefore(1), betadiff(1,4), betadiff(1,5), betadiff(1,6), betadiff(1,4)+betadiff(1,5), betadiff(1,6)-betadiff(1,4) ];
        irfinfV=[irfinfV; irf_inf50];
    elseif nbeta==3; %when nbeta=3 plot the raw yields
        maturities = [3 6 12 24 36 48 60 72 84 96 108 120]';
        TS_before=betabeforeV(tt,4:end); 
        TS_after=betaafterV(tt,4:end); 
        plot(maturities',TS_before,'b','LineWidth',2); hold on; plot(maturities',TS_after,'r-*');  
        str2=['title(''',num2str(betabeforeV(tt,2)),'/',num2str(betabeforeV(tt,1)),''',''FontSize'',14',');']; 
        eval(str2);
        legend('Yield Curve Before','Yield Curve After','Location','Best'); 
        xlabel('Maturity','FontSize',14); ylabel('Yield (%)','FontSize',14); hold off; 
        if period=='conven'; saveas(fn,strcat('figuresIRFSsmoothRAW/conventional/inflation',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        elseif period=='unconv'; saveas(fn,strcat('figuresIRFSsmoothRAW/unconventional/inflation',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        end; 
    end;
    close;  
    
    if nbeta==2; %plot decomp only when analyzing betas (not yields)
        fn=figure('visible','off'); 
        plot(decomp_inf(:,1),'o:'); hold on; 
        plot(decomp_inf(:,2)); hold off;
        ylabel('Percent','FontSize',14); xlabel('Horizon','FontSize',14); 
        lgd=legend('Contribution of \Delta\beta_2_t','Contribution of \Delta\beta_3_t'); lgd.FontSize = 14;
        str3=['title(''Decomposition of Inflation IRF on ',num2str(shock(tt,2)),'/',num2str(shock(tt,1)),''',''FontSize'',14',');']; 
        eval(str3);
        if period=='conven'; saveas(fn,strcat('figuresIRFSsmooth/conventional/inflation_decomp',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        elseif period=='unconv'; saveas(fn,strcat('figuresIRFSsmooth/unconventional/inflation_decomp',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        end
    close;       
    end;

    fn=figure; %fn=figure('visible','off'); 
    subplot(1,2,1); 
    plot(Hv,irf_output16','--r','LineWidth',2); hold on;
    plot(Hv,irf_output84','--r','LineWidth',2); 
    Hv2=[Hv,fliplr(Hv)]; inbetween=[irf_output16',fliplr(irf_output84')]; fill(Hv2, inbetween,[1 0.6 0.3]);
    plot(Hv,irf_output50','r','LineWidth',3); hold off; 
    ylabel('Percent','FontSize',14); xlabel('Horizon','FontSize',14);
    str1=['title(''Output IRF on ',num2str(shock(tt,2)),'/',num2str(shock(tt,1)),''',''FontSize'',14',');'];
    eval(str1);
    subplot(1,2,2); 
    if nbeta==2; %when nbeta==2 plot the change in NS
        plot(tau,TS_before,'b','LineWidth',2); hold on; plot(tau,TS_after,'r-*');  
        eval(str2);  legend('Yield Curve Before','Yield Curve After','Location','Best'); 
        xlabel('Maturity','FontSize',14); ylabel('Yield (%)','FontSize',14); hold off; 
        if period=='conven'; saveas(fn,strcat('figuresIRFSsmooth/conventional/output',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        elseif period=='unconv'; saveas(fn,strcat('figuresIRFSsmooth/unconventional/output',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        end;
        irfoutputV=[irfoutputV; irf_output50];
    elseif nbeta==3; %when nbeta=3 plot the raw yields
        maturities = [3 6 12 24 36 48 60 72 84 96 108 120]';
        TS_before=betabeforeV(tt,4:end); 
        TS_after=betaafterV(tt,4:end); 
        plot(maturities',TS_before,'b','LineWidth',2); hold on; plot(maturities',TS_after,'r-*');  
        str2=['title(''',num2str(betabeforeV(tt,2)),'/',num2str(betabeforeV(tt,1)),''',''FontSize'',14',');']; 
        eval(str2);
        legend('Yield Curve Before','Yield Curve After','Location','Best'); 
        xlabel('Maturity','FontSize',14); ylabel('Yield (%)','FontSize',14); hold off; 
        if period=='conven'; saveas(fn,strcat('figuresIRFSsmoothRAW/conventional/output',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        elseif period=='unconv'; saveas(fn,strcat('figuresIRFSsmoothRAW/unconventional/output',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        end; 
    end;
    close;  

    

    if nbeta==2; %plot decomp only when analyzing betas (not yields)
        fn=figure('visible','off'); 
        plot(decomp_output(:,1),'o:'); hold on; 
        plot(decomp_output(:,2)); hold off;
        ylabel('Percent','FontSize',14); xlabel('Horizon','FontSize',14); 
        lgd=legend('Contribution of \Delta\beta_2_t','Contribution of \Delta\beta_3_t'); lgd.FontSize = 14;
        str3=['title(''Decomposition of IRF of Output on ',num2str(shock(tt,2)),'/',num2str(shock(tt,1)),''',''FontSize'',14',');']; 
        eval(str3);
        if period=='conven'; saveas(fn,strcat('figuresIRFSsmooth/conventional/output_decomp',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        elseif period=='unconv'; saveas(fn,strcat('figuresIRFSsmooth/unconventional/output_decomp',num2str(shock(tt,2)),num2str(shock(tt,1))), 'epsc')
        end;
        close;
    end;
end

if nbeta==2; 
    cd figuresIRFSsmooth; 
    if period=='conven';        
        disp(deltabetaV); save deltabetaV_conven deltabetaV -ascii; 
        save irfinfV_smooth_conven irfinfV -ascii;
        save irfoutputV_smooth_conven irfoutputV -ascii;
        save irf_output_smooth_conven irf_output -ascii;
        save irf_inf_smooth_conven irf_inf -ascii;
    elseif period=='unconv';    
        disp(deltabetaV); save deltabetaV_unconv deltabetaV -ascii; 
        save irfinfV_smooth_unconv irfinfV -ascii;
        save irfoutputV_smooth_unconv irfoutputV -ascii;
        save irf_output_smooth_unconv irf_output -ascii;
        save irf_inf_smooth_unconv irf_inf -ascii;
    end;
    cd ..
end;