function plotTSandNS_final(betaT,yields,maturities,TimeV,lambda0,mpdates,year,month,day,period)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% plots of the shocks as shifts in TS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

plotMPshock=[]; jj=1; betamp=[];
for mdays=1:size(mpdates,1),
    a1=find(year==mpdates(mdays,3));
    a2=find(month==mpdates(mdays,2));
    aa1=intersect(a1,a2); 
    a3=find(day==mpdates(mdays,1));
    ttt=intersect(aa1,a3);
    fn=figure('visible','off'); %fn=figure;
    result_before=plot_ttt(betaT,yields,maturities,TimeV,lambda0,ttt-1); hold on;
    result_after=plot_ttt2(betaT,yields,maturities,TimeV,lambda0,ttt+1); hold off;
    str=[num2str(month(ttt)),'/', num2str(day(ttt)),'/',num2str(year(ttt))];
    title(str,'FontSize',14); xlabel('Maturity','FontSize',14); 
    lgd=legend('Raw Yield Before','Fitted Yield Before','Raw Yield After','Fitted Yield After','Location','Best'); 
    lgd.FontSize = 14;
    ylabel('Yield (%)','FontSize',14);
    hold off;
    %Save figure
    if period=='conven';
    saveas(fn,strcat('figuresMPSHOCK/conventional/TSchangeon',num2str(mpdates(mdays,2)),num2str(mpdates(mdays,3))), 'epsc')
    elseif period=='unconv';
    saveas(fn,strcat('figuresMPSHOCK/unconventional/TSchangeon',num2str(mpdates(mdays,2)),num2str(mpdates(mdays,3))), 'epsc')
    end;        
    %pause;
    %Save data for tables
    plotMPshock=[plotMPshock; jj,mdays,mpdates(mdays,[3,2,1]), result_after.TS-result_before.TS]; 
    betamp=[betamp; mpdates(mdays,[3,2,1]), result_after.beta-result_before.beta];
    jj=jj+1;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Plot of mp shock as a function
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tau=[1:1:120];
if period=='conven';
fn=figure; plot(tau,plotMPshock(58,6:end)); hold on; plot(tau,plotMPshock(29,6:end),'r:');
plot(tau,plotMPshock(33,6:end),'g*'); plot(tau,plotMPshock(43,6:end),'o');
plot(tau,plotMPshock(100,6:end),'r--'); plot(tau,plotMPshock(76,6:end),'c-.'); hold off; 
set(gca,'fontsize',14)
lgd=legend(num2str(plotMPshock(58,[4,5,3])), ...
num2str(plotMPshock(29,[4,5,3])), ...
num2str(plotMPshock(33,[4,5,3])), ...
num2str(plotMPshock(43,[4,5,3])), ...
num2str(plotMPshock(100,[4,5,3])), ...
num2str(plotMPshock(76,[4,5,3])));
%lgd.FontSize = 14;
ylabel('Percent','FontSize',14); xlabel('Maturity','FontSize',14);
end;
if period=='unconv';
fn=figure; 
plot(tau,plotMPshock(1,6:end),'m-*'); hold on; 
plot(tau,plotMPshock(3,6:end),'co');
plot(tau,plotMPshock(4,6:end),'r-');
plot(tau,plotMPshock(5,6:end),'b:');
plot(tau,plotMPshock(6,6:end),'g-.');
plot(tau,plotMPshock(7,6:end));
plot(tau,plotMPshock(8,6:end)),'k--';
plot(tau,plotMPshock(9,6:end));
plot(tau,plotMPshock(10,6:end),'k:s');
hold off; set(gca,'fontsize',14)
lgd=legend(num2str(plotMPshock(1,[4,5,3])), ...
num2str(plotMPshock(3,[4,5,3])), ...
num2str(plotMPshock(4,[4,5,3])), ...
num2str(plotMPshock(5,[4,5,3])), ...
num2str(plotMPshock(6,[4,5,3])), ...
num2str(plotMPshock(7,[4,5,3])), ...
num2str(plotMPshock(8,[4,5,3])), ...
num2str(plotMPshock(9,[4,5,3])), ...
num2str(plotMPshock(10,[4,5,3])),'Location','Best');
%lgd.FontSize = 14;
ylabel('Percent','FontSize',14); xlabel('Maturity','FontSize',14);
end;
if period=='conven';
saveas(fn,'figuresMPSHOCK/conventional/figureSHOCK', 'epsc');
elseif period=='unconv';
saveas(fn,'figuresMPSHOCK/unconventional/figureSHOCK', 'epsc');
end;       

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  TABLES WITH DELTA_BETAS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if period=='conven';
disp('Table of beta1 beta2 beta3 beta1+beta2 beta3-beta1 for these six dates')
bb=[betamp(58,4:6); betamp(29,4:6); betamp(33,4:6); betamp(43,4:6); betamp(100,4:6); betamp(76,4:6)];
bb=[bb,bb(:,1)+bb(:,2),bb(:,3)-bb(:,1)];
table_bb=[betamp(58,[2,3,1,4,5,6]); betamp(29,[2,3,1,4,5,6]); betamp(33,[2,3,1,4,5,6]); betamp(43,[2,3,1,4,5,6]); betamp(100,[2,3,1,4,5,6]); betamp(76,[2,3,1,4,5,6])];
table_bb=[table_bb,table_bb(:,4)+table_bb(:,5),table_bb(:,6)-table_bb(:,4)];
table_bb_all=[betamp(:,[2,3,1]), betamp(:,4:6),betamp(:,4)+betamp(:,5),betamp(:,6)-betamp(:,4)];
save table_deltabeta_conven table_bb_all -ascii;
elseif period=='unconv';
disp('Table of month day year beta1 beta2 beta3 beta1+beta2 beta3-beta1 for these six dates')
table_bb=[betamp(:,[2,3,1]), betamp(:,4:6),betamp(:,4)+betamp(:,5),betamp(:,6)-betamp(:,4)];
disp('Table of beta1 beta2 beta3 beta1+beta2 beta3-beta1 for these six dates')
save table_deltabeta_unconv table_bb -ascii;
end

%addpath C:\brossi\research\library\formatoTEX
if period=='conven'; matrix2latex(table_bb, 'TableDeltaBetaConventional.tex');
    matrix2latex(table_bb_all, 'TableDeltaBetaConventionalAllDates.tex');
elseif period=='unconv'; matrix2latex(table_bb, 'TableDeltaBetaUnconventional.tex'); 
end;






function result=plot_ttt(betaT,yields,maturities,TimeV,lambda0,ttt);
tau=[1:1:120];
scatter(maturities,yields(ttt,:));
linefit2=1*betaT(ttt,4)+((1-exp(-lambda0*tau))./(lambda0*tau))*betaT(ttt,5) + ((1-exp(-lambda0*tau))./(lambda0*tau)-exp(-lambda0*tau))*betaT(ttt,6);
hold on; plot(tau,linefit2,'b','LineWidth',2); 
result.TS=linefit2; result.beta=betaT(ttt,4:6);

function result=plot_ttt2(betaT,yields,maturities,TimeV,lambda0,ttt);
tau=[1:1:120];
scatter(maturities,yields(ttt,:),'r*');
linefit2=1*betaT(ttt,4)+((1-exp(-lambda0*tau))./(lambda0*tau))*betaT(ttt,5) + ((1-exp(-lambda0*tau))./(lambda0*tau)-exp(-lambda0*tau))*betaT(ttt,6);
hold on; plot(tau,linefit2,'r--','LineWidth',2);
result.TS=linefit2; result.beta=betaT(ttt,4:6);
