
function plot_correl(OURshock_T,RRshock_T,period,directory_name)
shock=OURshock_T;
RRshock=RRshock_T; 

%Use only shocks that are different from zero
% shock=OURshock_T(find(sum(OURshock_T(:,4:6),2)>eps),:);
% RRshock=RRshock_T(find(sum(OURshock_T(:,4:6),2)>eps),:); 

%Create Delta_TS1, ...
tau=[1:1:120]; lambda0 = 0.0609;
TS_change1=bsxfun(@times,shock(:,4),ones(1,size(tau,2)));
TS_change2=bsxfun(@times,shock(:,5),(1-exp(-lambda0*tau))./(lambda0*tau));
TS_change3=bsxfun(@times,shock(:,6),((1-exp(-lambda0*tau))./(lambda0*tau)-exp(-lambda0*tau)));
TS_change=TS_change1+TS_change2+TS_change3; 

OLS1=[]; OLS2=[]; OLS3=[]; OLSall=[];  OLS4=[];  
for j=1:size(TS_change,2); %loop over maturities
    OLS1=[OLS1; olsbeta(TS_change1(:,j),[ones(size(RRshock,1),1),RRshock(:,end)])]; 
    OLS2=[OLS2; olsbeta(TS_change2(:,j),[ones(size(RRshock,1),1),RRshock(:,end)])];
    OLS3=[OLS3; olsbeta(TS_change3(:,j),[ones(size(RRshock,1),1),RRshock(:,end)])];  
    OLSall=[OLSall; olsbeta(TS_change(:,j),[ones(size(RRshock,1),1),RRshock(:,end)])];
    OLS4=[OLS4; olsbeta(TS_change1(:,j)+TS_change2(:,j),[ones(size(RRshock,1),1),RRshock(:,end)])];  
end; 

    fn=figure; 
    p1=subplot(2,2,1); plot(OLS1(:,2),'r--'); 
    ylabel('\gamma_1(\tau)');  
    xlabel('Maturity (\tau)'); 
    
    p2=subplot(2,2,2); plot(OLS2(:,2),'r--');  
    ylabel('\gamma_2(\tau)');  
    xlabel('Maturity (\tau)');  
    
    p3=subplot(2,2,3); plot(OLS3(:,2),'r--'); 
    ylabel('\gamma_3(\tau)');  
    xlabel('Maturity (\tau)');  

    p4=subplot(2,2,4); plot(OLS4(:,2),'r--');  
    ylabel('\gamma_4(\tau)');  
    xlabel('Maturity (\tau)');  

    hold off;
    
str=['cd figuresCORREL\',directory_name]; eval(str);
    
if period=='conven';
    if directory_name=='Romer';
        linkaxes([p1,p2,p3,p4],'y'); p4.YLim = [-0.05,0.15];
        linkaxes([p1,p2,p3,p4],'x'); p4.XLim = [0,120];
    elseif directory_name=='Wuxia';
        linkaxes([p1,p2,p3,p4],'y'); p4.YLim = [-0.01,0.05];
        linkaxes([p1,p2,p3,p4],'x'); p4.XLim = [0,120];
    elseif directory_name=='Kripp';
        linkaxes([p1,p2,p3,p4],'y'); p4.YLim = [-0.15,0.5];
        linkaxes([p1,p2,p3,p4],'x'); p4.XLim = [0,120];
    end;
saveas(fn,strcat('FigCorrelConventional1234'), 'epsc');
elseif period=='unconv'; 
saveas(fn,strcat('FigCorrelUnconventional1234'), 'epsc');
end;    

fn=figure; plot(OLSall(:,2),'r--');  
ylabel('\gamma(\tau)'); xlabel('Maturity (\tau)'); 
if period=='conven';
saveas(fn,strcat('FigCorrelConventional'), 'epsc');
elseif period=='unconv';
saveas(fn,strcat('FigCorrelUnconventional'), 'epsc');
end;

str='cd ..; cd ..'; eval(str)