function scatterplot_beta(OURshockall,NSshock_T,oggetto)
shock_beta=OURshockall; 
ncl=size(OURshockall(:,4:end)); n=size(OURshockall,1);
indx = zeros(n,1); indx2 = zeros(n,1); indx3 = zeros(n,1); indx4 = zeros(n,1); indx5 = zeros(n,1);
for i=1:n

    if NSshock_T(i,4) >0 & NSshock_T(i,1)<2008 %contractionary conventional
        indx(i,1) = 1; 
    elseif NSshock_T(i,4) <0 & NSshock_T(i,1)<2008 %expansionary conventional
        indx2(i,1) = 1; 
    end
    if NSshock_T(i,1)>2007 & NSshock_T(i,1)<2013 %expansionary unconventional
        indx5(i,1) = 1;
    end;

end
 
shock_beta_contr_conv = shock_beta(indx==1,:); %contractionary conventional
shock_beta_expan_conv = shock_beta(indx2==1,:); %expansionary conventional
shock_beta_unconv = shock_beta(indx5==1,:); %unconventional

cd figuresSCATTER;  if oggetto=='betas'; cd betas; elseif oggetto=='yield'; cd yields; end; 

fn=figure; scatter3(shock_beta_contr_conv(:,4),shock_beta_contr_conv(:,5),shock_beta_contr_conv(:,6));
title('Conventional Monetary Policy: Contractionary Shock'); 
if oggetto=='betas'; xlabel('\Delta\beta_1_t'); ylabel('\Delta\beta_2_t'); zlabel('\Delta\beta_3_t');
elseif oggetto=='yield'; xlabel('\Delta 3-months Yield'); ylabel('\Delta 1-year Yield'); zlabel('\Delta 5-year Yield');
end; 
set(gca,'fontsize',14);
saveas(fn,strcat('conv_contract.eps'), 'epsc')

fn=figure; scatter3(shock_beta_expan_conv(:,4),shock_beta_expan_conv(:,5),shock_beta_expan_conv(:,6));
title('Conventional Monetary Policy: Expansionary Shock'); 
if oggetto=='betas'; xlabel('\Delta\beta_1_t'); ylabel('\Delta\beta_2_t'); zlabel('\Delta\beta_3_t');
elseif oggetto=='yield'; xlabel('\Delta 3-months Yield'); ylabel('\Delta 1-year Yield'); zlabel('\Delta 5-year Yield');
end; 
set(gca,'fontsize',14);
saveas(fn,strcat('conv_expan'), 'epsc')

fn=figure; scatter3(shock_beta_unconv(:,4),shock_beta_unconv(:,5),shock_beta_unconv(:,6));
title('Unconventional Monetary Policy'); 
if oggetto=='betas'; xlabel('\Delta\beta_1_t'); ylabel('\Delta\beta_2_t'); zlabel('\Delta\beta_3_t');
elseif oggetto=='yield'; xlabel('\Delta 3-months Yield'); ylabel('\Delta 1-year Yield'); zlabel('\Delta 5-year Yield');
end; 
set(gca,'fontsize',14); 
saveas(fn,strcat('unconv'), 'epsc')

fn=figure; scatter3(shock_beta_contr_conv(:,4),shock_beta_contr_conv(:,5),shock_beta_contr_conv(:,6),'MarkerEdgeColor','y', 'MarkerFaceColor','y');
hold on; scatter3(shock_beta_expan_conv(:,4),shock_beta_expan_conv(:,5),shock_beta_expan_conv(:,6),'MarkerEdgeColor','c', 'MarkerFaceColor','c');
scatter3(shock_beta_unconv(:,4),shock_beta_unconv(:,5),shock_beta_unconv(:,6),'MarkerEdgeColor','m', 'MarkerFaceColor','m');
title('Conventional and Unconventional Mon. Policy'); 
if oggetto=='betas'; xlabel('\Delta\beta_1_t'); ylabel('\Delta\beta_2_t'); zlabel('\Delta\beta_3_t');
elseif oggetto=='yield'; xlabel('\Delta 3-months Yield'); ylabel('\Delta 1-year Yield'); zlabel('\Delta 5-year Yield');
end; 
legend('Contractionary Conventional Shock','Expansionary Conventional Shock','Unconventional'); hold off;
set(gca,'fontsize',14);

cd .. 
cd ..